мир.объекты = {
    умолчание: {
        x: 0,
        y: 0,
        ширина: 40,
        высота: 20,
        физика: {
            isStatic: true,
        },
    },
    задано: {},
    тела: {},
    имена: {},
    элементы: {},
    свойстваТела: ["x", "y", "ширина", "высота", "физика"],
};


// // // //


мир.ключники.push(function(ключ, путь, значение){
    if (!ключ.startsWith("объекты"))
    {
        return;
    }

    var имя = путь[1];
    var свойство = путь[2];

    if (!(имя in мир.объекты.задано))
    {
        мир.объекты.задано[имя] = {};
    }
    var свойствоПуть = путь.slice(2).join(".");
    мир.объекты.задано[имя][свойствоПуть] = значение;

    мир.объекты.пересоздатьТело(имя, свойство);
    мир.объекты.обновитьЭлемент(имя, свойство, значение);
    мир.объекты.обновитьВидЭлемента(путь, имя, свойство, значение);
});


// // // //


мир.объекты.обновить = function()
{
    for (var имя in мир.объекты.тела)
    {
        var тело = мир.объекты.тела[имя];
        var элемент = мир.объекты.элементы[имя];
        if (!тело || !элемент)
        {
            continue;
        }
        var засинхрили = мир.синхронизироватьЭлементТело(элемент, тело);

        // Учесть значения transform из JSON-JS.
        if (засинхрили)
        {
            var transform = мир.объекты.задано[имя]["вид.transform"];
            if (transform)
            {
                элемент.style.transform += transform;
            }
        }
    }
};


// // // //


мир.объекты.пересоздатьТело = function(имя, свойство)
{
    if (!мир.объекты.свойстваТела.includes(свойство))
    {
        return;
    }

    // Удалить физическое тело.
    if (имя in мир.объекты.тела)
    {
        var тело = мир.объекты.тела[имя];
        Matter.Composite.remove(мир.физика.движок.world, тело);
        delete мир.объекты.имена[тело.id];
    }
    // Пересоздать физическое тело.
    var за = мир.объекты.задано[имя];
    var ум = мир.объекты.умолчание;

    var x = за.x != null ? за.x : ум.x;
    var y = за.y != null ? за.y : ум.y;
    var ширина = за.ширина ? за.ширина : ум.ширина;
    var высота = за.высота ? за.высота : ум.высота;
    // Переводим x,y из левого-верхнего угла в центр.
    x = x + ширина / 2.0;
    y = y + высота / 2.0;
    var физика = {};
    Object.assign(физика, ум.физика);
    for (var путь in за)
    {
        if (путь.startsWith("физика"))
        {
            var свойство = путь.slice(7);
            мир.задать(физика, свойство, за[путь]);
        }
    }

    var тело = Matter.Bodies.rectangle(x, y, ширина, высота, физика);
    Matter.Composite.add(мир.физика.движок.world, тело);
    мир.объекты.тела[имя] = тело;
    мир.объекты.имена[тело.id] = имя;
};


// // // //


мир.объекты.обновитьЭлемент = function(имя, свойство, значение)
{
    var за = мир.объекты.задано[имя];
    var ум = мир.объекты.умолчание;

    if (!(имя in мир.объекты.элементы))
    {
        var элемент = document.createElement("div");
        элемент.id = `объекты-${имя}`;
        элемент.style.position = "absolute";
        элемент.style.display = "block";
        элемент.style.transformOrigin = "center";
        document.getElementById("корень").appendChild(элемент);
        мир.объекты.элементы[имя] = элемент;
        // Свойства по умолчанию.
        элемент.style.width = `${ум.ширина}px`;
        элемент.style.height = `${ум.высота}px`;
    }

    var элемент = мир.объекты.элементы[имя];

    if (свойство == "ширина")
    {
        var ширина = за["ширина"] ? за["ширина"] : ум["ширина"];
        элемент.style.width = `${ширина}px`;
    }
    else if (свойство == "высота")
    {
        var высота = за["высота"] ? за["высота"] : ум["высота"];
        элемент.style.height = `${высота}px`;
    }
}


// // // //


мир.объекты.обновитьВидЭлемента = function(путь, имя, свойство, значение)
{
    if (свойство != "вид")
    {
        return;
    }
    
    var элемент = мир.объекты.элементы[имя];
    var параметр = путь[3];
    элемент.style.setProperty(параметр, значение);
}
